abstract type AbstractFeynmanVertex end

struct QEDFeynmanVertex <: AbstractFeynmanVertex end

#=
"""
    FeynmanVertex

Vertex of a specific [`AbstractTreeLevelFeynmanDiagram`](@ref).
"""
struct FeynmanVertex{P1,P2,P3,N} where {N,P1<:AbstractParticleType,P2<:AbstractParticleType,P3<:AbstractParticleType}
    p1::BitArray{N}
    p2::BitArray{N}
    p3::BitArray{N}
end

# convenience functions for equivalence of FeynmanVertex types
_vtype_isequal(v1::Type{FeynmanVertex}, v2::Type{FeynmanVertex}) = false
_vtype_isequal(v1::Type{FeynmanVertex{P1,P2,P3,N}}, v2::Type{FeynmanVertex{P1,P2,P3,N}}) where {N,P1,P2,P3} = true
_vtype_isequal(v1::Type{FeynmanVertex{P1,P2,P3,N}}, v2::Type{FeynmanVertex{P1,P3,P2,N}}) where {N,P1,P2,P3} = true
_vtype_isequal(v1::Type{FeynmanVertex{P1,P2,P3,N}}, v2::Type{FeynmanVertex{P2,P1,P3,N}}) where {N,P1,P2,P3} = true
_vtype_isequal(v1::Type{FeynmanVertex{P1,P2,P3,N}}, v2::Type{FeynmanVertex{P2,P3,P1,N}}) where {N,P1,P2,P3} = true
_vtype_isequal(v1::Type{FeynmanVertex{P1,P2,P3,N}}, v2::Type{FeynmanVertex{P3,P1,P2,N}}) where {N,P1,P2,P3} = true
_vtype_isequal(v1::Type{FeynmanVertex{P1,P2,P3,N}}, v2::Type{FeynmanVertex{P3,P2,P1,N}}) where {N,P1,P2,P3} = true
=#
